C.....******************************************************************
C.....
C.....     PROGRAMME *** CELREF ***                         7/10/78
C.....
C.....     AUTEURS : JEAN LAUGIER & ALAIN FILHOL    20/10/78
C.....
C.....     AFFINEMENT LES PARAMETRES DE MAILLE
C.....                DU DECALAGE DE ZERO
C.....                DE LA LONGUEUR D'ONDE
C.....     A PARTIR DES ANGLES THETA DE BRAGG OBSERVES
C.....
C.....     METHODE : MOINDRES CARRES NON LINEAIRES
C.....
C.....     DONNEES :
C.....        1- CARTE COMMENTAIRE          FORMAT(16A5)
C.....        2- INDIC,IFIN                 FORMAT(2I)
C.....           INDIC  : CONTRAINTE D'AFFINEMENT
C.....                    0/1/2 POUR (A,B,C INDEPENDANTS)/(A=B=C)/(A=B)
C.....           IFIN   : NOMBRE MAXIMUM DE CYCLES D'AFFINEMENT
C.....
C.....        3- B(2),B(1)                       FORMAT(2F)
C.....           B(2)   : LONGUEUR D'ONDE
C.....           B(1)   : DECALAGE SYSTEMATIQUE DE ZERO
C.....
C.....        4- AFI(2),AFI(1)                   FORMAT(2F)
C.....           AFI(2) : 0/1 AFFINER (NON)/(OUI) LA LONGUEUR D'ONDE
C.....           AFI(1) :  "    "         "       LE DECALAGE DE ZERO
C.....
C.....        5- B(3 A 8)                        FORMAT(6F)
C.....           B(3)   : PARAMETRE A
C.....           B(4)   : PARAMETRE B
C.....           B(5)   : PARAMETRE C
C.....           B(6)   : ANGLE ALPHA
C.....           B(7)   : ANGLE BETA
C.....           B(8)   : ANGLE GAMMA
C.....
C.....        6- AFI(3 A 8)                      FORMAT(6F)
C.....           AFI(3 A 8) : 0/1 POUR AFFINER (NON)/(OUI)
C.....                        LES PARAMETRES DE MAILLE
C.....
C.....        7 A 7+NR- H,K,L,THETA              FORMAT(3I,F)
C.....          ("NR" NOMBRE D'OBSERVATIONS)
C.....          (DERNIERE CARTE : H,K,L=0 0 0)
C.....           H,K,L  : INDICES DE MILLER
C.....           THETA  : ANGLE DE BRAGG OBSERVE
C.....
C.....*****************************************************************
C
C
      character*20 file
      character*24 tmp
      logical qex
      INTEGER ITITR(20),H(200),K(200),L(200)
      REAL*8 ICLE(3)
      DIMENSION THETA(200),SIG(8),DUM(3)
      EXTERNAL CALC
      COMMON/TROC/IWR,IRID
      COMMON/TRUC/QQ(200,10),BB(10),B(10),H,K,L,NPAF,AFI(10),NR,
     1            INDIC,PDS(200),NPAF2
      DATA IRID,IWR/15,16/,ICLE/'A=B=C','A=B  ','NO   '/
      DATA SIG/8*0./
C
C----- A MODIFIER EN CAS DE CHANGEMENT DES DIMENSIONS
      NDMAX=200
C-----
      RD=180./ACOS(-1.)
C.....
C.....ENTREE DES DONNEES
   10 FORMAT(' PROGRAM *** CELREF ***  (J.LAUGIER & A.FILHOL 10/78)'/)
   20 FORMAT(20A4)
   30 FORMAT(10I)
   40 FORMAT(6F)
   50 FORMAT(3I,F)
   60 FORMAT(1H0,72(1H-)/1H ,20A4/1H ,72(1H-)//
     1      ' OBSERVABLE NUMBER    : ',I5/
     1      ' ITERATION NUMBER : ',I5/
     1      ' REFINEMENT CONSTRAINTS : ',A5)
   70 FORMAT(' NUMBER OF INDEPENDENT PARAMETERS : ',I5/)
   80 FORMAT(' INITIAL VALUES :')
   90 FORMAT(' FINAL VALUES   : (STANDARD DEVIATIONS : 2nd LINE)'/
     1 ' ## WARNING ## REFINEMENT CONSTRAINTS APPLY TO RECIPROCAL PARAME
     1TERS, NOT TO DIRECT ONES')
  100 FORMAT(4X,'ZERO',4X,'LAMBDA',6X,'A',8X,'B',8X,'C',6X,
     1      'ALPHA',5X,'BETA',4X,'GAMMA')
  110 FORMAT(2X,F6.3,3X,F7.4,3(2X,F7.4),3(2X,F7.3))
  120 FORMAT(' RECIPROCAL CELL : ',3(2X,F7.5),3(2X,F7.3)/
     1       ' VOLUME (A**3)  : ',F9.3/)
  130 FORMAT(6X,F2.0,7(7X,F2.0))
  140 FORMAT(1H0,3X,1HH,5X,1HK,5X,1HL,2X,'TH(OBS)',4X,'TH-ZERO',4X,
     1      'TH(CALC)',5X,'DIFF.'/)
  150 FORMAT(2X,3(I3,3X),4(F6.3,5X))
  160 FORMAT(' SQRT(SUM(TH O-C)**2)/(NREF-NPAR))*1000 = ',F10.4/
     1 ' FACTEUR R : ',F10.4)
  170 FORMAT(' ##### ERROR REFLEXION : ',3I4,F8.3)
  180 FORMAT(' ##### DATA NUMBER GREATER THAN ',I4,' #####')
  190 FORMAT(' ##### IMPOSSIBLE TO REFINE ALL PARAMETERS TOGETHER'
     1 '##### THINK, PLEASE ! #####')
C
C.....ENTREE DES DONNEES
      print 3
    3 FORMAT('         ERACEL is built from CELREF'/
     &'                       by'/
     &'         J.LAUGIER & A.FILHOL 10-1978'/
     &'  ERACEL is a cell parameter refinement program'/)
      print 191
191   format('  entry .dat file (no extension) ??',$)
      read 192,file
192   format(A20)
      lfile=len(file)
      do while (file(lfile:lfile).eq.' ')
      lfile=lfile-1
      enddo
      tmp=file(1:lfile)//'.dat'
      call open_read1(15,tmp)
      tmp=file(1:lfile)//'.imp'
      inquire(file=tmp,exist=qex)
      if(qex.eq..FALSE.) go to 11
      print *,'warning, this old file will be deleted :',tmp
      call filedel(16,tmp)
11    call open_write1(16,tmp)
      PRINT 193
193   FORMAT(' BE CAREFUL : INPUT DATA IN 2-THETA (), OUTPUT IN THETA')
      WRITE(IWR,10)
      READ(IRID,20)ITITR
      READ(IRID,*)INDIC,IFIN
      IF(INDIC.EQ.0.OR.INDIC.GT.3) INDIC=3
      READ(IRID,*)B(2),B(1)
      READ(IRID,*)AFI(2),AFI(1)
      READ(IRID,*)(B(I),I=3,8),(AFI(I),I=3,8)
      IFFI=IFIX(AFI(3)+AFI(4)+AFI(5)+0.1)
      IF(IFFI.EQ.0.OR.INDIC.EQ.3)GOTO 230
      IK=3-INDIC
      DO 220 I=1,IK
      IF(INDIC-2)200,210,210
  200 AFI(2+INDIC+I)=0.
      GOTO 220
  210 AFI(2+INDIC-1+I)=0.
  220 CONTINUE
      AFI(3)=1.
C
  230 NR=0
  240 NR=NR+1
      IF(NR.GT.NDMAX)GOTO 380
      READ(IRID,*,END=260)H(NR),K(NR),L(NR),THETA(NR)
      IHKL=IABS(H(NR))+IABS(K(NR))+IABS(L(NR))
      IF(IHKL.EQ.0)GOTO 260
      IF(THETA(NR).LE.0.)GOTO 370
  250 PDS(NR)=1.
      THETA(NR)=THETA(NR)/RD/2.   !!!!! 2*THETA EN THETA
      GOTO 240
C.....
  260 NR=NR-1
      WRITE(IWR,60)ITITR,NR,IFIN,ICLE(INDIC)
      WRITE(IWR,80)
      WRITE(IWR,100)
      WRITE(IWR,130)(AFI(I),I=1,8)
      WRITE(IWR,110)(B(I),I=1,8)
      B(1)=B(1)/RD
      B(2)=B(2)*0.5
      DO 270 I=6,8
  270 B(I)=B(I)/RD
C   ...... CALCUL DES PARAMETRES MAILLE RECIPROQUE
      CALL INVER(B,DUM,VOLUM,0)
C   ......
      DO 280 I=1,3
  280 DUM(I)=B(5+I)*RD
      WRITE(IWR,120)(B(I),I=3,5),DUM,VOLUM
C
C....."NPAF" : NOMBRE DE PARAMETRES A AFFINER
C....."BB()" : TABLEAU DES PARAMETRES A AFFINER
      J=0
      DO 290 I=1,8
      IF(AFI(I).EQ.0.)GOTO 290
      J=J+1
      BB(J)=B(I)
  290 CONTINUE
      NPAF=J
      WRITE(IWR,70)NPAF
      IF(NPAF.EQ.8)GOTO 390
      NPAF2=NPAF+2
C   ......AFFINEMENT   (PDS() : POIDS (NON-UTILISE POUR CETTE VERSION))
      CALL MCRNL(QQ,NDMAX,THETA,BB,NPAF,NR,PDS,IFIN,CALC)
C   ......
C
C.....NOUVELLES VALEURS DES PARAMETRES
      J=0
      DO 300 I=1,8
      IF(AFI(I).EQ.0.)GOTO 300
      J=J+1
      B(I)=BB(J)
  300 CONTINUE
C   ......VALEURS DES ANGLES THETA CALCULES
      CALL FONC(THETA,R,RR)
C   ......
C
C.....CALCUL DES ECARTS TYPE
C....."SIG()" LES ECARTS TYPE DES PARAMETRES DE MAILLE QU'IL
C.....        CONTIENT SONT CEUX DES PARAMETRES RECIPROQUES.
      JJ=0
      DO 330 I=1,8
      IF(AFI(I))320,310,320
  310 SIG(I)=0.
      GOTO 330
  320 JJ=JJ+1
      SIG(I)=SQRT(QQ(JJ,JJ)*R)
  330 CONTINUE
      IF(INDIC.EQ.1.OR.INDIC.EQ.2) SIG(4)=SIG(3)
      IF(INDIC.EQ.1) SIG(5)=SIG(3)
      DO 340 I=1,3
      BB(I)=B(I+2)
  340 BB(I+3)=B(I+5)*RD
C
C   ......RETOUR A LA MAILLE DIRECT (ET ECARTS TYPE CORRESPONDANTS)
      CALL INVER(B,SIG,VOLUM,1)
C   ......
      SIG(1)=SIG(1)*RD
      SIG(2)=SIG(2)*2.
C
C.....SORTIE DES RESULTATS
      VOLUM=1./VOLUM
      B(1)=B(1)*RD
      B(2)=B(2)*2.
      DO 350 I=6,8
      SIG(I)=SIG(I)*RD
  350 B(I)=B(I)*RD
      WRITE(IWR,90)
      WRITE(IWR,100)
      WRITE(IWR,110)(B(I),I=1,8)
      WRITE(IWR,110)(SIG(I),I=1,8)
      WRITE(IWR,120)(BB(I),I=1,6),VOLUM
      WRITE(IWR,140)
      WRITE(6,90)
      WRITE(6,100)
      WRITE(6,110)(B(I),I=1,8)
      WRITE(6,110)(SIG(I),I=1,8)
      WRITE(6,120)(BB(I),I=1,6),VOLUM
      NPOUR=0
      DO 360 I=1,NR
      Y1=THETA(I)*RD
      Y2=Y1-B(1)
      Y3=QQ(I,NPAF2)*RD - B(1)
      Y4=Y2-Y3
      IF(ABS(Y4).GT.0.02)print 361
      IF(ABS(Y4).GT.0.02)NPOUR=NPOUR+1
      IF(ABS(Y4).GT.0.02)GO TO 360
      IF(ABS(Y4).GT.0.01)print 362
361   FORMAT('  DO IT AGAIN : YOUR DATA ARE REALLY DUMB : DIF>0.02 !')
362   FORMAT('  YOUR DATA ARE ALMOST DUMB : 0.01>DIF<0.02')
  360 WRITE(IWR,150)H(I),K(I),L(I),Y1,Y2,Y3,Y4
      IF(NPOUR.GT.0)print 363,NPOUR,NPOUR
363   FORMAT(////
     1'  YOU HAVE  'I4' DATA REALLY DUMB WITH : DIF>0.02 '/
     2'  TO PRINT THIS RESULT WOULD BE PAPER WASTE....')
      R=SQRT(R)*1000.
      WRITE(IWR,160)R,RR
      IF(NPOUR.GT.0)GOTO 400
      print 365
365   FORMAT('  Do you want a JCPDS-type output with hkl, dobs and
     2 dcalc ?'/
     3'  YES=0, NO=1 '$)
      READ(5,*)NREP
      IF(NREP.EQ.1)GOTO 400
      WRITE(IWR,366)
  366 FORMAT(1H0,3X,1HH,5X,1HK,5X,1HL,5X,'D(OBS)',4X,'D(CALC)'/)
      DO 367 I=1,NR
      Y0=B(2)/2.
      Y1=Y0/SIN(THETA(I)-B(1)/RD)
      Y2=Y0/SIN(QQ(I,NPAF2)-B(1)/RD)
  367 WRITE(IWR,368)H(I),K(I),L(I),Y1,Y2
  368 FORMAT(2X,3(I3,3X),2(F7.4,5X))
      print 369
  369 FORMAT(/' The JCPDS output is at the end of the .imp file')
      GOTO 400
C
C.....MESSAGES D'ERREUR
  370 WRITE(IWR,170)H(NR),K(NR),L(NR),THETA(NR)
      NR=NR-1
      GOTO 240
  380 WRITE(IWR,180)NDMAX
      GOTO 400
  390 WRITE(IWR,190)
  400 PRINT 6
   6  FORMAT('        Thanks for using ERACEL')
      STOP
      END
C
C
      SUBROUTINE CALC
C.....--------------
      INTEGER H(200),K(200),L(200)
      COMMON/TRUC/QQ(200,10),BB(10),B(10),H,K,L,NPAF,AFI(10),NR,
     *            INDIC,PDS(200),NPAF2
      DIMENSION Q(200,10)
      COMMON/TROC/IWR,IRID
      J=0
      DO 1 I=1,8
      IF(AFI(I).EQ.0.)GO TO 1
      J=J+1
      B(I)=BB(J)
1     CONTINUE
      IF(INDIC.EQ.1.OR.INDIC.EQ.2)B(4)=B(3)
      IF(INDIC.EQ.1)B(5)=B(3)
      AE=B(3)
      BE=B(4)
      CE=B(5)
      CAE=COS(B(6))
      CBE=COS(B(7))
      CCE=COS(B(8))
      DO 2 I=1,NR
      DD=(AE*H(I))**2+(BE*K(I))**2+(CE*L(I))**2
     *+2.*(H(I)*K(I)*AE*BE*CCE+K(I)*L(I)*BE*CE*CAE
     *+L(I)*H(I)*CE*AE*CBE)
      D=1./SQRT(DD)
      RAD=SQRT(1.-(B(2)**2)*DD)
      F=B(2)*D/RAD
      Q(I,1)=1.
      Q(I,2)=1./(D*RAD)
      Q(I,3)=F*H(I)*(H(I)*AE+K(I)*BE*CCE+L(I)*CE*CBE)
      Q(I,4)=F*K(I)*(K(I)*BE+L(I)*CE*CAE+H(I)*AE*CCE)
      Q(I,5)=F*L(I)*(L(I)*CE+H(I)*AE*CBE+K(I)*BE*CAE)
      Q(I,6)=-F*K(I)*L(I)*BE*CE*SIN(B(6))
      Q(I,7)=-F*L(I)*H(I)*CE*AE*SIN(B(7))
      Q(I,8)=-F*H(I)*K(I)*AE*BE*SIN(B(8))
2     QQ(I,NPAF2)=B(1)+ASIN(B(2)/D)
      DO 3 IR=1,NR
      J=0
      DO 3 I=1,8
      IF(AFI(I).EQ.0.)GO TO 3
      J=J+1
      QQ(IR,J)=Q(IR,I)
3     CONTINUE
      WRITE(IWR,5)(BB(I),I=1,NPAF)
5     FORMAT(2X,8(E13.7,2X),/)
      RETURN
      END
C
C
      SUBROUTINE FONC(THETA,R,RR)
C.....-----------------------
      DIMENSION THETA(200)
      INTEGER H(200),K(200),L(200)
      COMMON/TRUC/QQ(200,10),BB(10),B(10),H,K,L,NPAF,AFI(10),NR,
     *            INDIC,PDS(200),NPAF2
      R1=0.
      R2=0.
      AE=B(3)
      BE=B(4)
      CE=B(5)
      CAE=COS(B(6))
      CBE=COS(B(7))
      CCE=COS(B(8))
      DO 2 I=1,NR
      DD=(AE*H(I))**2+(BE*K(I))**2+(CE*L(I))**2
     *+2.*(H(I)*K(I)*AE*BE*CCE+K(I)*L(I)*BE*CE*CAE
     *+L(I)*H(I)*CE*AE*CBE)
      D=1./SQRT(DD)
      YC=B(1)+ASIN(B(2)/D)
      R1=R1+(YC-THETA(I))**2
      R2=R2+THETA(I)**2
2     QQ(I,NPAF2)=YC
      R=R1/(NR-NPAF)
      RR=SQRT(R1/R2)
      RETURN
      END
C
C
      SUBROUTINE MCRNL(Q,ID,Y,B,M,N,P,IFIN,CALC)
C.....------------------------------------------
C
C.....PROGRAMME DE MOINDRES CARRES NON LINEAIRE
C.....UTILISANT L'INVERSION DE MATRICE TABLEAU A UNE DIMENSION
C.....LIMITE A 15 PARAMETRES
C..... M = NBRE DE PARAMETRES
C..... N = NBRE DE DONNEES
C..... ID = DIMENSION DU TABLEAU Q(ID,M+1) 
C..... A((M*(M-1)/2 + M) = ZONE DE TRAVAIL
C
      DIMENSION Q(ID,1),Y(1),B(1),P(1),A(60)
      MM=2*M
      M1=M+1
      M2=M+2
   10 IFIN=IFIN-1
C
C-----CALCUL DES DERIVEES PARTIELLES ET DES Y
      CALL CALC
C
C-----LES Y CALCULES SONT DANS LA COLONNE M+2
      DO 30 J=1,M
      R=0.
      DO 20 I=1,N
   20 R=R+(Y(I)-Q(I,M2))*Q(I,J)*P(I)
   30 Q(J,M1)=R
C
C-----CONSTRUCTION DE LA MATRICE SYMETRIQUE A=Q*QT
      NO=0
      DO 50 IQ=1,M
      DO 50 IL=IQ,M
      NO=NO+1
      R=0.
      DO 40 I=1,N
   40 R=R+Q(I,IQ)*Q(I,IL)*P(I)
   50 A(NO)=R
C
C-----INVERSION DE LA MATRICE A
      CALL MATINV(A,M,IER)
      IF(IFIN)110,110,60
C
C-----CALCUL DES NOUVEAUX PARAMETRES
   60 DO 100 I=1,M
      R=0.
      IMM=(I-1)*(MM-I)/2
      DO 90 J=1,M
      IF(J-I)80,70,70
   70 L=IMM+J
      GOTO 90
   80 L=(J-1)*(MM-J)/2+I
   90 R=R+A(L)*Q(J,M1)
  100 B(I)=B(I)+R
      GOTO 10
C
C-----REMISE DES ELEMENTS DIAGONAUX DANS Q(I,I),APRES LE DERNIER CYCLE
  110 DO 120 I=1,M
      L=(I-1)*(MM-I)/2+I
  120 Q(I,I)=A(L)
      RETURN
      END
C
C
      SUBROUTINE MATINV(AM,N,NFAIL)
C.....-----------------------------
      DIMENSION AM(1)
      DOUBLE PRECISION SUMA
C     ********** SEGMENT 1 OF CHOLESKI INVERSION **********
C     ***** FACTOR MATRIX INTO LOWER TRIANGLE X TRANSPOSE *****
      K=1
      IF(N-1)80,10,20
   10 AM(1)=1.0/AM(1)
      GOTO 200
C     ***** LOOP M OF A(L,M) *****
   20 DO 110 M=1,N
      IMAX=M-1
C     ***** LOOP L OF A(L,M) *****
      DO 100 L=M,N
      SUMA=0.0
      KLI=L
      KMI=M
      IF(IMAX)50,50,30
C     *****SUM OVER I=1,M-1 A(L,I)*A(M,I) *****
   30 DO 40 I=1,IMAX
      SUMA=SUMA+AM(KLI)*AM(KMI)
      J=N-I
      KLI=KLI+J
   40 KMI=KMI+J
C     *****TERM=C(L,M)-SUM *****
   50 TERM=AM(K)-SUMA
      IF(L-M)60,60,90
   60 IF(TERM)80,80,70
C     ***** A(M,M)=SQRT(TERM) *****
   70 DENOM=SQRT(TERM)
      AM(K)=DENOM
      GOTO 100
   80 NFAIL= K
      GOTO 210
C     ***** A(L,M)=TERM/A(M,M) *****
   90 AM(K)=TERM/DENOM
  100 K=K+1
  110 CONTINUE
C     ********** SEGMENT 2 OF CHOLESKI INVERSION **********
C     *****INVERSION OF TRIANGULAR MATRIX*****
  120 AM(1)=1.0/AM(1)
      KDM=1
C     ***** STEP L OF B(L,M) *****
      DO 150 L=2,N
      KDM=KDM+N-L+2
C     ***** RECIPROCAL OF DIAGONAL TERM *****
      TERM = 1.0/AM(KDM)
      AM(KDM)=TERM
      KMI=0
      KLI=L
      IMAX=L-1
C     ***** STEP M OF B(L,M) *****
      DO 140 M=1,IMAX
      K=KLI
C     ***** SUM TERMS *****
      SUMA=0.0
      DO 130 I=M,IMAX
      II=KMI+I
      SUMA=SUMA-AM(KLI)*AM(II)
  130 KLI=KLI+N-I
C     ***** MULT SUM * RECIP OF DIAGONAL *****
      AM(K)=SUMA*TERM
      J=N-M
      KLI=K+J
  140 KMI=KMI+J
  150 CONTINUE
C     ********** SEGMENT 3 OF CHOLESKI INVERSION **********
C     *****PREMULTIPLY LOWER TRIANGLE BY TRANSPOSE*****
  160 K=1
      DO 190 M=1,N
      KLI=K
      DO 180 L=M,N
      KMI=K
      IMAX=N-L+1
      SUMA=0.0
      DO 170 I=1,IMAX
      SUMA=SUMA+AM(KLI)*AM(KMI)
      KLI=KLI+1
  170 KMI=KMI+1
      AM(K)=SUMA
  180 K=K+1
  190 CONTINUE
  200 NFAIL=0
  210 RETURN
      END
C
C
      SUBROUTINE INVER(B,DB,VOLUM,IV)
C.....
C.....  1-CALCUL LES PARAMETRES MAILLE INVERSE
C.....  2-CALCULE LES ECARTS TYPE DES PARAMETRES
C.....   IV=0 OPTION 1  IV=1 OPTIONS 1 & 2
C.....
      DIMENSION B(8),DB(8)
      DIMENSION AD(6),D(6),SINP(3),COSP(3),SP(3),SS(3),
     1          CC(3),DQD(3),SIG(6)
C
      CABC2=0.
      DO 10 I=1,3
      AD(I)=B(I+2)
      COSP(I)=COS(B(I+5))
      SINP(I)=SIN(B(I+5))
   10 CONTINUE
      DO 15 I=1,3
      J=MOD(I,3)+1
      K=MOD(I+1,3)+1
      DQD(I)=COSP(I)-COSP(J)*COSP(K)
      SS(I)=SINP(J)*SINP(K)
      CC(I)=-DQD(I)/SS(I)
      CABC2=CABC2+COSP(I)*COSP(I)
   15 CONTINUE
C
      Q2=1.-CABC2+2.*COSP(1)*COSP(2)*COSP(3)
      Q=SQRT(Q2)
      VOLUM=AD(1)*AD(2)*AD(3)*Q
C
      DO 20 I=1,3
      B(I+2)=SINP(I)/(AD(I)*Q)
      B(I+5)=ACOS(CC(I))
      SP(I)=SIN(B(I+5))
   20 CONTINUE
C
      IF(IV.EQ.0)GOTO 70
C
C.....DERIVEES DES PARAMETRES A , B , C
      DO 30 I=1,3
      J=MOD(I,3)+1
      K=MOD(I+1,3)+1
      D(I)=-SINP(I)/AD(I)
      D(J)=0.
      D(K)=0.
      D(I+3)=COSP(I)-SINP(I)*SINP(I)*DQD(I)/(Q*Q)
      D(J+3)=-SS(K)*DQD(J)/Q2
      D(K+3)=-SS(J)*DQD(K)/Q2
      CALL SIGMA(D,DB,R)
   30 SIG(I)=SQRT(R)/(Q*AD(I))
C
C.....DERIVEES DES ANGLES DE LA MAILLE
      DO 50 I=1,3
      DO 40 JJ=1,3
   40 D(JJ)=0.
      J=MOD(I,3)+1
      K=MOD(I+1,3)+1
      D(I+3)=SINP(I)/SS(I)
      D(J+3)=COSP(K)/SINP(K) + COSP(J)*CC(I)/SINP(J)
      D(K+3)=COSP(J)/SINP(J) + COSP(K)*CC(I)/SINP(K)
      CALL SIGMA(D,DB,R)
   50 SIG(I+3)=SQRT(R)/SP(I)
C
      DO 60 I=1,6
   60 DB(I+2)=SIG(I)
C
   70 RETURN
      END
C
C
      SUBROUTINE SIGMA(D,DB,R)
C.....
      DIMENSION DB(8),D(6)
      R=0.
      DO 10 I=1,6
   10 R=R + (D(I)*DB(I+2))**2
      RETURN
      END
C
      subroutine open_read1(unit,file)
      integer unit
      character*(*) file
      open (unit,file=file,status='old')
      return
      end
      subroutine open_write1(unit,file)
      integer unit
      character*(*) file
      open (unit,file=file,status='new')
      return
      end
      subroutine filedel(unit,file)
      integer unit
      character*(*) file
      open (unit,file=file,status='old')
      close (unit,status='delete')
      return
      end
